package main

import (
	"encoding/json"
	"fmt"
	"log"
	"sync"
	"time"

	"github.com/474420502/focus/tree/heap"
	"github.com/gin-gonic/gin"
)

var tagCounter = &sync.Map{} // make(map[string]*tagcounter)

type taginfo struct {
	Name  string
	Value int
}

type tagcounter struct {
	Name      string
	LastTime  time.Time
	CountWord map[string]*taginfo
	PQueue    []interface{}
}

func init() {

}

func AllTag(cxt *gin.Context) {
	countTagInfo(cxt, func(cxt *gin.Context, cw *tagcounter) {
		cxt.JSON(200, cw.CountWord)
	})
}

func CountTag(cxt *gin.Context) {
	countTagInfo(cxt, func(cxt *gin.Context, cw *tagcounter) {
		cxt.JSON(200, cw.PQueue)
	})
}

func countTagInfo(cxt *gin.Context, ret func(cxt *gin.Context, cw *tagcounter)) {
	platform := cxt.Query("platform")
	var cw *tagcounter

	if icw, ok := tagCounter.Load(platform); ok {
		cw = icw.(*tagcounter)
		if time.Now().Sub(cw.LastTime).Minutes() <= 10 {
			ret(cxt, cw)
			return
		}
	}

	sql := fmt.Sprintf(SqlTag, platform)
	rows, err := StoreStreamer.Query(sql)
	if err != nil {
		cxt.Error(err)
		return
	}

	cw = &tagcounter{}
	cw.CountWord = make(map[string]*taginfo)
	cw.Name = platform
	cw.LastTime = time.Now()

	for rows.Next() {
		var stag string
		err = rows.Scan(&stag)
		if err != nil {
			log.Println(err)
		}
		var tag []string
		json.Unmarshal([]byte(stag), &tag)
		for _, t := range tag {
			if _, ok := cw.CountWord[t]; ok {
				cw.CountWord[t].Value++
			} else {
				cw.CountWord[t] = &taginfo{Name: t, Value: 1}
			}
		}
	}

	heap := heap.New(func(a, b interface{}) int {
		if a.(*taginfo).Value >= b.(*taginfo).Value {
			return 1
		}
		return -1

	})

	var other = &taginfo{Name: "Other...", Value: 0}
	var i = 0
	for _, v := range cw.CountWord {
		if i <= 99 {
			heap.Put(v)
		} else {
			break
		}
		i++
	}

	if heap.Size() == 0 {
		cxt.JSON(200, nil)
		return
	}

	// heap.Put(other)
	cw.PQueue = heap.Values()
	other.Value = cw.PQueue[len(cw.PQueue)-1].(*taginfo).Value - 1
	if other.Value == 0 {
		other.Value = 1
	}

	cw.PQueue = append(cw.PQueue, other)
	// cxt.JSON(200, cw.PQueue)
	ret(cxt, cw)
	cw.LastTime = time.Now()
	tagCounter.Store(platform, cw)
}
